/*
 * bolzano
 *
 * Copyright © 2000 Guillem Jover <guillem@hadrons.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 */

#include <stdio.h>
#include <math.h>

static long double
f(long double x)
{
	return (pow(x, 3) - 4 * x + 2);
}

int
main()
{
	long double a, b, c, E;
	unsigned long i;

	a = 1;
	b = 2;
	E = 1;
	for (i = 60; i; i--) {
		c = (a + b) / 2;
		if (f(a) * f(c) < 0)
			b = c;
		else
			a = c;
		E /= 2;
	}
	printf("'x3 - 4x + 2 = 0' -> %.18Lf  E = %.20Lg\n", c, E);

	return 0;
}
